/*
tvorit pomoci seznamu

struktura -  aspon 3 polozky (text, cislo)

mazat - konkretni polozku
editovat
mazat vse
nacist ze souboru
ulozit do souboru
tridit podle abecedy i cisel
hledat (cislo i retezec)
vypsat


Finferle - mp3
Fousek - VideoPujcovna
Muller - kontakty
Nikolov - Fotky
Nemec - Knihovna
Rychtarik - Slecny (jmeno, miry, tel. cislo)
*/

#include <stdio.h>
#include <conio.h>
#include <stdlib.h>

#define DELKAJMENA 30
#define JMENOSOUBORU "data.bin"

typedef struct osoba {
	char jmeno[DELKAJMENA+1];
	int rokNarozeni;
} OSOBA;

typedef struct polozka {
	OSOBA *data;
	struct polozka *dalsi;
} POLOZKA;

enum {
	MNU_NOVA='p',
	MNU_SMAZATVSE='s',
	MNU_ULOZITVSE='u',
	MNU_NACISTVSE='n',
	MNU_VYPSATVSE='v',
	MNU_KONEC='k'
};

typedef enum {
	STAV_OK,
	STAV_CHYBA
} STAV;

OSOBA *VytvorOsobu() {
	OSOBA *o;
	char buf[20];
	o=(OSOBA*) malloc(sizeof(OSOBA));
	if (o==NULL) { // nepodarila se vyalokovat pamet
		printf("\n ... NENI DOSTATEK PAMETI ...");
		return NULL;
	}
	sprintf(buf,"%%%d[^\n]",DELKAJMENA);// buf="%30[^\n]"
	fflush(stdin); // zahodim vsechny drive nactene znaky
	printf("\nZadej jmeno:");
	scanf(buf,o->jmeno);
	fflush(stdin);
	printf("Zadej rok narozeni:");
	scanf("%d",&(o->rokNarozeni));
	fflush(stdin);
	return o;
}

void VypisOsobu(OSOBA *jakou) {
	if (jakou==NULL) {
		printf("\n ... NEEXISTUJICI OSOBA ...");
	} else {
		printf("\n%s se narodil(a) v roce %d", jakou->jmeno, jakou->rokNarozeni);
	}
}


STAV PridejDoSeznamu(POLOZKA **prvni, OSOBA *co) {
	POLOZKA *nova;
	if (co==NULL) {
		printf("\n ... NEBUDU PRIDAVAT NEEXISTUJICI OSOBU !!");
		return STAV_CHYBA;
	}
	nova=(POLOZKA*) malloc(sizeof(POLOZKA));
	if (nova==NULL) {
		printf("\n ... NENI DOSTATEK PAMETI PRO POLOZKU, SMAZU PRIDAVANOU OSOBU:");
		VypisOsobu(co);
		free(co);
		return STAV_CHYBA;
	}
	nova->data=co;
	nova->dalsi=*prvni;
	*prvni=nova;
	return STAV_OK;
}

void SmazSeznam(POLOZKA **prvni) {
	POLOZKA *pom;
	while(*prvni!=NULL) {
		pom=*prvni;
		*prvni=pom->dalsi;
		if (pom->data) free(pom->data);
		free(pom);
	}
}

void VypisSeznam(POLOZKA *prvni) {
	if (prvni==NULL) {
		printf("\n .. SEZNAM JE PRAZDNY ... !!!");
	}
	while (prvni) {
		VypisOsobu(prvni->data);
		prvni=prvni->dalsi;
	}
}

void UlozDoSouboru(POLOZKA *prvni, char *jmenoSouboru) {
	FILE *f;
	if (prvni==NULL) {
		printf("\n ... NENI CO UKLADAT ... !!!");
		return;
	}
	f=fopen(jmenoSouboru, "wb");
	if (f==NULL) {
		printf("\n ... NEPODARILO SE VYTVORIT SOUBOR \'%s\' !!!",jmenoSouboru);
		return;
	}
	for (;prvni;prvni=prvni->dalsi) {
		if (prvni->data==NULL) continue; // kdyz nahodou neexistuje osoba v polozce
		if (1!=fwrite(prvni->data,sizeof(OSOBA), 1, f)) {
			printf("\n ... NEPODARILO SE ULOZIT CELY SEZNAM !!!");
			break;
		}
	}
	if (EOF==fclose(f)) {
		printf("\n ... NEPODARILO SE UZAVRIT SOUBOR, MOHLO DOJIT KE ZTRATE DAT ...");
	}
}

void NactiZeSouboru(POLOZKA **prvni, char *jmenoSouboru) {
	FILE *f;
	OSOBA *o;
	if (*prvni) SmazSeznam(prvni);
	f=fopen(jmenoSouboru, "rb");
	if (f==NULL) {
		printf("\n ... NEPODARILO SE OTEVRIT SOUBOR \'%s\', mozna neexistuje !!!",jmenoSouboru);
		return;
	}
	while (1) {
		o=(OSOBA*) malloc(sizeof(OSOBA));
		if (o==NULL){
			printf("\n ... NEDOSTATEK PAMETI PRO VYTVORENI OSOBY, SOUBOR NENACTEN CELY");
			break;
		}
		if (1!=fread(o,sizeof(OSOBA), 1, f)) break; // konec souboru - jediny spravny break
		if (STAV_CHYBA == PridejDoSeznamu(prvni, o)) {
			printf("\n ... NEDOSTATEK PAMETI PRO POLOZKU SEZNAMU, SOUBOR NENACTEN CELY");
			break;
		}
	}
	if (EOF==fclose(f)) {
		printf("\n ... NEPODARILO SE UZAVRIT SOUBOR, MOHLO DOJIT KE ZTRATE DAT ...");
	}
}

void main() {
	int volba;
	POLOZKA *prvni=NULL;
	do {
		printf("\n\n");
		printf("\n%c...Pridat osobu",MNU_NOVA);
		if (prvni) printf("\n%c...Ulozit do souboru", MNU_ULOZITVSE);
		printf("\n%c...Nacist ze souboru", MNU_NACISTVSE);
		if (prvni) {
			printf("\n%c...Vypsat vse", MNU_VYPSATVSE);
			printf("\n%c...Smazat vse", MNU_SMAZATVSE);
		}
		printf("\n%c...Konec", MNU_KONEC);
		printf("\nVase volba?->");
		volba=getche();
		if (volba==MNU_KONEC) break;
		switch (volba) {
			case MNU_NOVA:
				PridejDoSeznamu(&prvni, VytvorOsobu());
				break;
			case MNU_ULOZITVSE:
				if (prvni) UlozDoSouboru(prvni,JMENOSOUBORU);
				break;
			case MNU_NACISTVSE:
				NactiZeSouboru(&prvni,JMENOSOUBORU);
				break;
			case MNU_VYPSATVSE:
				if (prvni) VypisSeznam(prvni);
				break;
			case MNU_SMAZATVSE:
				if (prvni) SmazSeznam(&prvni);
				break;
			default:
				printf("\n ... SPATNA VOLBA !!!");
				break;
		}
	} while (volba!=MNU_KONEC);
	SmazSeznam(&prvni);
}

